using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using localhost;


public partial class VerMisSubastas : System.Web.UI.Page
{
  DataTable dttSubastas;
  Service1 objWS;
  TUsuario usuario;

  void Page_Load(object sender, EventArgs e)
  {

    if (!Page.IsPostBack)
    {

      usuario = (TUsuario)Session["Usuario"];
      objWS = (Service1)Session["objWS"];

      if (objWS == null)
        objWS = new Service1();

      objWS.SecuredWebServiceHeaderValue = new SecuredWebServiceHeader();
      objWS.SecuredWebServiceHeaderValue.Username = usuario.NickName;
      objWS.SecuredWebServiceHeaderValue.Password = usuario.Password;
      objWS.SecuredWebServiceHeaderValue.AuthenticatedToken = usuario.Token;

    }
    else
    {
      objWS = (Service1)Session["objWS"];
      usuario = (TUsuario)Session["Usuario"];
      dttSubastas = (DataTable)Session["dttSubastas"];

      if (dttSubastas != null)
        grdMisSubastas.DataSource = dttSubastas;
    }

    if (usuario != null)
    {
      lblUsuario.Text = "Usuario Validado : " + usuario.NickName;
      hblMisSubastas.NavigateUrl = "VerMisSubastas.aspx?IDUsuario=" + usuario.IDUsuario.ToString();

    }
    else
    {
      lblUsuario.Text = "";
      hblMisSubastas.Text = "Validar";
      hblMisSubastas.NavigateUrl = "ValidarUsuario.aspx";
    }

  }

  protected void Page_UnLoad(object sender, EventArgs e)
  {
    Session["objWS"] = objWS;
    Session["Usuario"] = usuario;
    Session["dttSubastas"] = dttSubastas;
  }

  protected void grdSubastas_Sorting(object sender, GridViewSortEventArgs e)
  {
  }

  protected void grdSubastas_PageIndexChanging(object sender, GridViewPageEventArgs e)
  {
  }

}