using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using System.IO;
using localhost;
using SubastasCli;

public partial class Votar : System.Web.UI.Page
{
  Service1 objWS;
  TUsuario usuario;
  TTotalComentario objTTotalComentario;
  TSubasta objSubasta;
  string strPaginaAnterior;

  void Page_Load(object sender, EventArgs e)
  {

    if (!Page.IsPostBack)
    {

      usuario = (TUsuario)Session["Usuario"];
      objWS = (Service1)Session["objWS"];
      strPaginaAnterior = (string)Session["strPaginaAnterior"];
      objSubasta = (TSubasta)Session["Subasta"];

      if (objWS == null)
        objWS = new Service1();


      strPaginaAnterior = Request.UrlReferrer.ToString();

    }
    else
    {
      objWS = (Service1)Session["objWS"];
      usuario = (TUsuario)Session["Usuario"];
      objSubasta = (TSubasta)Session["Subasta"];
      strPaginaAnterior = (string)Session["strPaginaAnterior"];
    }


    if (usuario != null)
    {
      lblUsuario.Text = "Usuario Validado : " + usuario.NickName;
      hblMisSubastas.NavigateUrl = "VerMisSubastas.aspx?IDUsuario=" + usuario.IDUsuario.ToString();

    }
    else
    {
      lblUsuario.Text = "";
      hblMisSubastas.Text = "Validar";
      hblMisSubastas.NavigateUrl = "ValidarUsuario.aspx";
    }


  }

    protected void Page_UnLoad(object sender, EventArgs e)
    {
      Session["objWS"] = objWS;
      Session["Usuario"] = usuario;
      Session["strPaginaAnterior"] = strPaginaAnterior;
      Session["Subasta"] = objSubasta;
    }
  
    protected void btnCancelar_Click(object sender, EventArgs e)
    {
      Response.Redirect(strPaginaAnterior);
    }

    protected void btnVotar_Click(object sender, EventArgs e)
    {
      TComentario objComentario = new TComentario();
      //objSubasta, usuario.IDUsuario, 

      objComentario.IDSubasta = objSubasta.IDSubasta;
      int intVoto;
      Int32.TryParse(rbtnVotacion.SelectedValue.ToString(),out intVoto);
      if (objSubasta.IDComprador == usuario.IDUsuario)
        objComentario.IDComentarioVendedor = intVoto;
      if (objSubasta.IDVendedor == usuario.IDUsuario)
        objComentario.IDComentarioComprador = intVoto;

      objWS.SecuredWebServiceHeaderValue = new SecuredWebServiceHeader();
      objWS.SecuredWebServiceHeaderValue.Username = usuario.NickName;
      objWS.SecuredWebServiceHeaderValue.Password = usuario.Password;
      objWS.SecuredWebServiceHeaderValue.AuthenticatedToken = usuario.Token;

      if (objWS.CrearComentario(objComentario)>0)
        Label1.Text="El comentario ha sido creado correctamente.";
      else
        Label1.Text="Error al crear el comentario.";
    }
}
