using System;
using System.Data;
using System.Configuration;
using System.Data.SqlClient;
using System.Web.UI.WebControls;
using System.Collections;
using System.Collections.Generic;
using System.Collections.Specialized;
using System.Globalization;
using System.Web.Security;


namespace SubastasWs.TClassBase
{

   ///+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
   /// 
   /// Clase Acceso a Base de Datos
   /// 
   ///+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
   public class TDB
   {


      internal static SqlConnection sqlConexion;


     public string strERROR;

     public string ERROR { get { return strERROR; } set { strERROR = value; } }

     static TDB()
      {
    
         sqlConexion = CadenadeConexion();
      }

 
      public static SqlConnection CadenadeConexion()
      {
         return new SqlConnection(ConfigurationManager.ConnectionStrings["DBConnStr"].ConnectionString);
      }

 


      public static SqlConnection Conexion() 
      {
          return sqlConexion;
      }


      public bool ProbarConexion()
      {
         try
         {
            sqlConexion.Open();
            return true;
         }
         catch (System.Exception excExcepcion)
         {
            ERROR = excExcepcion.ToString();
            
            return false;
         }
         finally
         {
            sqlConexion.Close();
         }
      }

   

     public string DimeError()
     {
       return strERROR;

     }

   }

   ///+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
   /// 
   /// Clase TBaseBBDD 
   /// 
   ///+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
   public class TBaseBBDD
   {
      protected SqlCommand sqlInsertCMD = null;
      protected SqlCommand sqlUpdateCMD = null;
      protected SqlCommand sqlDeleteCMD = null;
      private SqlCommand sqlSelectCMD = null;
      private SqlCommand sqlProcedureCMD = null;



      public string ERROR;


       protected string InsertCMD
      {
         get { return sqlInsertCMD.CommandText; }
         set
         {
            if (sqlInsertCMD == null)
               sqlInsertCMD = new SqlCommand(value, TDB.Conexion());
            else
            {
               sqlInsertCMD.CommandText = value;
               sqlInsertCMD.Parameters.Clear();
            }
         }
      }

      protected string UpdateCMD
      {
         get { return sqlUpdateCMD.CommandText; }
         set
         {
            if (sqlUpdateCMD == null)
               sqlUpdateCMD = new SqlCommand(value, TDB.Conexion());
            else
            {
               sqlUpdateCMD.CommandText = value;
               sqlUpdateCMD.Parameters.Clear();
            }
         }
      }

      protected string DeleteCMD
      {
         get { return sqlDeleteCMD.CommandText; }
         set
         {
            if (sqlDeleteCMD == null)
               sqlDeleteCMD = new SqlCommand(value, TDB.Conexion());
            else
            {
               sqlDeleteCMD.CommandText = value;
               sqlDeleteCMD.Parameters.Clear();
            }
         }
      }

      protected string SelectCMD
      {
         get { return sqlSelectCMD.CommandText; }
         set
         {
            if (sqlSelectCMD == null)
               sqlSelectCMD = new SqlCommand(value, TDB.Conexion());
            else
            {
               sqlSelectCMD.CommandText = value;
               sqlSelectCMD.Parameters.Clear();
            }
         }
      }

     protected SqlDataReader LectorProcedure(string value, SqlParameter[] parms)
     {
       SqlDataReader dr;
         if (sqlProcedureCMD == null)
         {
            sqlProcedureCMD = new SqlCommand(value, TDB.Conexion());
         }
     
            sqlProcedureCMD.CommandText = value;
            sqlProcedureCMD.CommandType = CommandType.StoredProcedure;
            sqlProcedureCMD.Parameters.Clear();

         if (parms != null)
         {
		      	foreach (SqlParameter prm in parms)
		    	  {
		    	  	sqlProcedureCMD.Parameters.Add(prm);
	   		    }
         }

         try
         {
           TDB.Conexion().Open();
           dr = sqlProcedureCMD.ExecuteReader(CommandBehavior.CloseConnection);


         }
         catch (System.Exception excExcepcion)
         {
           dr = null;
           ERROR = excExcepcion.ToString();
           TDB.Conexion().Close();
         }

       return dr;
     }



     protected DataSet LectorProcedureDataSet(string value, SqlParameter[] parms)
     {
        DataSet dsLector = new DataSet(); 

       
       if (sqlProcedureCMD == null)
       {
         sqlProcedureCMD = new SqlCommand(value, TDB.Conexion());
       }

       SqlDataAdapter dtaTemp = new SqlDataAdapter(sqlProcedureCMD.CommandText, TDB.Conexion());

       sqlProcedureCMD.CommandText = value;
       sqlProcedureCMD.CommandType = CommandType.StoredProcedure;
       sqlProcedureCMD.Parameters.Clear();

       if (parms != null)
       {
         foreach (SqlParameter prm in parms)
         {
           sqlProcedureCMD.Parameters.Add(prm);
         }
       }

       try
       {
         TDB.Conexion().Open();
         sqlProcedureCMD.ExecuteNonQuery();//  .ExecuteReader(CommandBehavior.CloseConnection);
         dtaTemp.Fill(dsLector);

         TDB.Conexion().Close();
       }
       catch (System.Exception excExcepcion)
       {
         ERROR = excExcepcion.ToString();
         TDB.Conexion().Close();
         dsLector = null;
       }

       return dsLector;
     }


      protected void ProcedureCMD(String value, ref ArrayList lstParametrosIn)//,ArrayList lstParametrosOut)
      {
         SqlParameter[] sqls;
         //SqlParameter retValue;

         if (sqlProcedureCMD == null)
         {
           sqlProcedureCMD = new SqlCommand(value, TDB.Conexion());
            sqls = new SqlParameter[lstParametrosIn.Count];
            IEnumerable enumParametros = (IEnumerable)lstParametrosIn;
            int intContador = 0;
            foreach (SqlParameter obj in enumParametros)
            {
               sqls[intContador] = obj;
               intContador++;
            }

            sqlProcedureCMD.CommandType = CommandType.StoredProcedure;
            sqlProcedureCMD.Parameters.Clear();
            sqlProcedureCMD.Parameters.AddRange(sqls);


         }
         else
         {
            sqls = new SqlParameter[lstParametrosIn.Count];
            IEnumerable enumParametros = (IEnumerable)lstParametrosIn;
            int intContador = 0;
            foreach (SqlParameter obj in enumParametros)
            {
               sqls[intContador] = obj;
               intContador++;
            }

            sqlProcedureCMD.CommandText = value;
            sqlProcedureCMD.CommandType = CommandType.StoredProcedure;
            sqlProcedureCMD.Parameters.Clear();
            sqlProcedureCMD.Parameters.AddRange(sqls);

         }


         try
         {
           TDB.Conexion().Open();
            sqlProcedureCMD.ExecuteNonQuery();

            IEnumerable enumParametros = (IEnumerable)lstParametrosIn;
            int intContador = 0;
            foreach (SqlParameter obj in enumParametros)
            {
               obj.Value = sqlProcedureCMD.Parameters[intContador].Value;
               intContador++;
             }
         }
         catch (System.Exception excExcepcion)
         {
            ERROR = excExcepcion.ToString();
         }
         finally
         {
           TDB.Conexion().Close();
         }
      }


     protected bool ProcedureCMD(String value, ref SqlParameter[] parms)
     {
       bool blnResultado=false;
        
       if (sqlProcedureCMD == null)
         sqlProcedureCMD = new SqlCommand(value, TDB.Conexion());
       else
         sqlProcedureCMD.CommandText = value;

       sqlProcedureCMD.CommandType = CommandType.StoredProcedure;
       sqlProcedureCMD.Parameters.Clear();
       sqlProcedureCMD.Parameters.AddRange(parms);

       try
       {
         sqlProcedureCMD.CommandTimeout = 3600;
         TDB.Conexion().Open();
         sqlProcedureCMD.ExecuteNonQuery();
         blnResultado = true;
       }
       catch (System.Exception excExcepcion)
       {
         ERROR = excExcepcion.ToString();
         blnResultado = false;
       }
       finally
       {
         TDB.Conexion().Close();
       }

       return blnResultado;
     }


      protected DataSet DevuelveDataSet()
      {
         ERROR = "";

         DataSet dsLector = new DataSet(); ;

         SqlDataAdapter dtaTemp = new SqlDataAdapter(sqlSelectCMD.CommandText, TDB.Conexion());

         try
         {
           sqlSelectCMD.CommandTimeout = 90;
           TDB.Conexion().Open();
            dtaTemp.Fill(dsLector);
         }
         catch (System.Exception excExcepcion)
         {
            ERROR = excExcepcion.ToString();

         }
         finally
         {
           TDB.Conexion().Close();
         }

         if (dsLector.Tables.Count > 0)
         {
           if (dsLector.Tables[0].Rows.Count == 0)
             return null;
           else
             return dsLector;
         }
         else
           return null;

      }


      protected DataTable DevuelveTabla()
      {
         DataTable dtTabla = new DataTable();
         SqlDataAdapter dtaTemp = new SqlDataAdapter(sqlSelectCMD.CommandText, TDB.Conexion());

         try
         {
           TDB.Conexion().Open();
            dtaTemp.Fill(dtTabla);
         }
         catch (System.Exception excExcepcion)
         {
            ERROR = excExcepcion.ToString();
         }
         finally
         {
           TDB.Conexion().Close();
         }

         return dtTabla;
      }

      protected int InsertaCampos()
      {
         try
         {
            sqlInsertCMD.Connection.Open();
            int r = sqlInsertCMD.ExecuteNonQuery();
            return r;
         }
         catch (System.Exception excExcepcion)
         {
            ERROR = excExcepcion.ToString();
            return -1;
         }
         finally
         {
           TDB.Conexion().Close();
         }
      }


      protected bool InsertaCampos(out int intIdentity)
      {
         try
         {
            // Esto es lo que necesitamos para que nos devuelva el ID
            string cmdRetID = " select cast(scope_identity() as int);";

            // Nos aseguramos de que el commandtext inicial lleve finalizador de sentencia -;-
            if (!sqlInsertCMD.CommandText.Trim().EndsWith(";")) sqlInsertCMD.CommandText += ';';

            sqlInsertCMD.CommandText += cmdRetID;

            sqlInsertCMD.Connection.Open();

            // Le metemos todo el mondongo.
            intIdentity = (Int32)sqlInsertCMD.ExecuteScalar();

            return true;
         }
         catch (System.Exception excExcepcion)
         {
            intIdentity = 0;
            ERROR = excExcepcion.ToString();
            return false;
         }
         finally
         {
            sqlInsertCMD.Parameters.Clear();
            TDB.Conexion().Close();
         }
      }



      protected int BorraCampos()
      {
         try
         {
            sqlDeleteCMD.Connection.Open();
            int r = sqlDeleteCMD.ExecuteNonQuery();
            return r;
         }
         catch (System.Exception excExcepcion)
         {
            ERROR = excExcepcion.ToString();
            return -1;
         }
         finally
         {
           sqlDeleteCMD.Parameters.Clear();
           TDB.Conexion().Close();
         }
      }

      protected int ActualizaCampos()
      {
         try
         {
            sqlUpdateCMD.Connection.Open();
            int r = sqlUpdateCMD.ExecuteNonQuery();
            return r;
         }
         catch (System.Exception excExcepcion)
         {
            ERROR = excExcepcion.ToString();
            return -1;
         }
         finally
         {
           sqlUpdateCMD.Parameters.Clear();
           TDB.Conexion().Close();
         }
      }



     public static DataSet ConvertirADataSet(SqlDataReader reader)
     {
       DataSet dataSet = new DataSet();
       do
       {
         // Create new data table

         DataTable schemaTable = reader.GetSchemaTable();
         DataTable dataTable = new DataTable();

         if (schemaTable != null)
         {
           // A query returning records was executed

           for (int i = 0; i < schemaTable.Rows.Count; i++)
           {
             DataRow dataRow = schemaTable.Rows[i];
             // Create a column name that is unique in the data table
             string columnName = (string)dataRow["ColumnName"]; 
             // Add the column definition to the data table
             DataColumn column = new DataColumn(columnName, (Type)dataRow["DataType"]);
             dataTable.Columns.Add(column);
           }

           dataSet.Tables.Add(dataTable);

           // Fill the data table we just created

           while (reader.Read())
           {
             DataRow dataRow = dataTable.NewRow();

             for (int i = 0; i < reader.FieldCount; i++)
               dataRow[i] = reader.GetValue(i);

             dataTable.Rows.Add(dataRow);
           }
         }
         else
         {
           // No records were returned

           DataColumn column = new DataColumn("RowsAffected");
           dataTable.Columns.Add(column);
           dataSet.Tables.Add(dataTable);
           DataRow dataRow = dataTable.NewRow();
           dataRow[0] = reader.RecordsAffected;
           dataTable.Rows.Add(dataRow);
         }
       }
       while (reader.NextResult());
       return dataSet;
     }


   }




   ///+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
   /// 
   /// Interface TiBBDD 
   /// 
   ///+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

   public interface TiBBDD
   {
      bool CargaConCodigo(string strCodigo);
      bool CargaConCodigo(int intID);
      DataSet CargaDataSet();
      bool CargaDataRowEnObjeto(DataRow r);
   }

   ///+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
   /// 
   /// Clase TArticulo
   /// 
   ///+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
   public class TArticulo : TBaseBBDD, TiBBDD
   {
      private int intIDArticulo;
      private string strNombre;
      private string strDescripcion;
      private string strImagen;
      private int intIDCategoria;

      public int IDArticulo { get { return intIDArticulo; } set { intIDArticulo = value; } }
      public string Nombre { get { return strNombre; } set { strNombre = value; } }
      public string Descripcion { get { return strDescripcion; } set { strDescripcion = value; } }
      public string Imagen { get { return strImagen; } set { strImagen = value; } }
      public int IDCategoria { get { return intIDCategoria; } set { intIDCategoria = value; } }

      public TArticulo()
      {
      }

      public virtual DataSet CargaDataSet()
      {
         SelectCMD = "select * from articulo";
         return DevuelveDataSet();
      }


      public virtual DataSet CargaDataSet(string strCodigo)
      {
        SelectCMD = "select * from articulo where idarticulo = " + strCodigo;
         return DevuelveDataSet();
      }

      
      #region Miembros de TiBBDD

      public virtual bool CargaConCodigo(string strCodigo)
      {
        DataTable tblTemp;

         SelectCMD = "select TOP 1 * from articulo where idarticulo = " + strCodigo;

         tblTemp = DevuelveTabla();

         if (tblTemp.Rows.Count > 0)
         {
           return CargaDataRowEnObjeto(tblTemp.Rows[0]);
         }
         else
            return false;
      }


      public bool CargaDataRowEnObjeto(DataRow r)
      {

         try
         {
           this.IDArticulo = Int32.Parse(r["idarticulo"].ToString());
         }
         catch { this.IDArticulo = 0; };

         this.Nombre = r["nombre"].ToString();
         this.Descripcion = r["descripcion"].ToString();
         this.Imagen = r["imagen"].ToString();

        try
        {
          this.IDCategoria = Int32.Parse(r["idcategoria"].ToString());
        }
        catch { this.IDCategoria = 0; };

         return true;
      }

      public virtual bool CargaConCodigo(int intID)
      {
         return CargaConCodigo(intID.ToString());
      }

      #endregion

      public int Borrar()
      {

        // Ya crea el objeto sqlInsertCMD
        DeleteCMD = "DELETE FROM articulo WHERE idarticulo=@idarticulo";


        sqlDeleteCMD.Parameters.Add("@idarticulo", SqlDbType.Int).Value = this.IDArticulo;

        return BorraCampos();
      }


      public int Insertar()
      {
        this.Imagen = "http://www.subastas.es/imagenes/";
        // Ya crea el objeto sqlInsertCMD
        InsertCMD = "INSERT INTO articulo (nombre,descripcion,imagen,idcategoria)"
          + " VALUES (@nombre,@descripcion,@imagen,@idcategoria)";

        sqlInsertCMD.Parameters.Add("@nombre", SqlDbType.VarChar,200).Value = this.Nombre;
        sqlInsertCMD.Parameters.Add("@descripcion", SqlDbType.VarChar, 500).Value = this.Descripcion;
        sqlInsertCMD.Parameters.Add("@imagen", SqlDbType.VarChar, 200).Value = this.Imagen;
        sqlInsertCMD.Parameters.Add("@idcategoria", SqlDbType.Int).Value = this.IDCategoria;

        int intIdentity;
        if (InsertaCampos(out intIdentity))
        {
          this.IDArticulo=intIdentity;
          UpdatearImagen();
        }
        else
          intIdentity = -1;

        return intIdentity;
      }

      


      public void UpdatearImagen()
      {
       UpdateCMD = "UPDATE articulo SET imagen=@imagen "
        + " WHERE idarticulo=@idarticulo";

        sqlUpdateCMD.Parameters.Add("@imagen", SqlDbType.VarChar, 200).Value = this.Imagen + DimeNombreImagen(); 
        sqlUpdateCMD.Parameters.Add("@idarticulo", SqlDbType.Int).Value = this.IDArticulo;
        ActualizaCampos();
      }

      public int Updatear()
      {

        UpdateCMD = "UPDATE articulo SET nombre=@nombre,descripcion=@descripcion,imagen=@imagen,idcategoria=@idcategoria "
        + " WHERE idarticulo=@idarticulo";

        sqlUpdateCMD.Parameters.Add("@nombre", SqlDbType.VarChar, 200).Value = this.Nombre;
        sqlUpdateCMD.Parameters.Add("@descripcion", SqlDbType.VarChar, 500).Value = this.Descripcion;
        sqlUpdateCMD.Parameters.Add("@imagen", SqlDbType.VarChar, 200).Value = this.Imagen;
        sqlUpdateCMD.Parameters.Add("@idcategoria", SqlDbType.Int).Value = this.IDCategoria;
        sqlUpdateCMD.Parameters.Add("@idarticulo", SqlDbType.Int).Value = this.IDArticulo;

        /*if (this.FechaFactura == DateTime.MinValue)
          sqlUpdateCMD.Parameters.Add("@DFECHAFACTURA", SqlDbType.DateTime).Value = DBNull.Value;
        else
          sqlUpdateCMD.Parameters.Add("@DFECHAFACTURA", SqlDbType.DateTime).Value = this.FechaFactura;
        if (this.NumFactura == null)
          sqlUpdateCMD.Parameters.Add("@V20NUMFACTURA", SqlDbType.VarChar, 20).Value = "";
        else
          sqlUpdateCMD.Parameters.Add("@V20NUMFACTURA", SqlDbType.VarChar, 20).Value = this.NumFactura;*/

        return ActualizaCampos();
      }

      public string DimeNombreImagen()
      {
        string strID = this.IDArticulo.ToString();
        while (strID.Length < 5)
          strID = "0" + strID;
        return strID+".jpg";
      }

   }

   ///+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
   /// 
   /// Clase TComentario
   /// 
   ///+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
   public class TComentario : TBaseBBDD, TiBBDD
   {
      private int intIDComentario;
      private int intIDSubasta;
      private int intIDComentarioComprador;
      private int intIDComentarioVendedor;

      public int IDComentario { get { return intIDComentario; } set { intIDComentario = value; } }
      public int IDSubasta { get { return intIDSubasta; } set { intIDSubasta = value; } }
      public int IDComentarioComprador { get { return intIDComentarioComprador; } set { intIDComentarioComprador = value; } }
      public int IDComentarioVendedor { get { return intIDComentarioVendedor; } set { intIDComentarioVendedor = value; } }

      public TComentario()
      {
      }

       public virtual DataSet CargaDataSet()
      {
         SelectCMD = "select * from comentario";
         return DevuelveDataSet();
      }

       public DataSet CargaDataSetPorSubasta(string strIDSubasta)
       {
         SelectCMD = "select * from comentario where idsubasta=" + strIDSubasta;
         return DevuelveDataSet();
       }


      #region Miembros de TiBBDD

     

      public bool CargaConCodigo(string strCodigo)
      {
         DataTable tblTemp;

         SelectCMD = "select TOP 1 * from comentario where idcomentario=" + strCodigo;

         tblTemp = DevuelveTabla();

         if (tblTemp.Rows.Count > 0)
         {
           return CargaDataRowEnObjeto(tblTemp.Rows[0]);
         }
         else
            return false;
      }


      public bool Existe(string strCodigoSubasta)
      {
        DataTable tblTemp;

        SelectCMD = "select TOP 1 * from comentario where idsubasta=" + strCodigoSubasta;

        tblTemp = DevuelveTabla();

        if (tblTemp.Rows.Count > 0)
        {
          return true;
        }
        else
          return false;
      }

      public bool CargaDataRowEnObjeto(DataRow r)
      {


        try
        {
          this.IDComentario = Int32.Parse(r["idcomentario"].ToString());
        }
        catch { this.IDComentario = 0; };
        try
        {
          this.IDSubasta = Int32.Parse(r["idsubasta"].ToString());
        }
        catch { this.IDSubasta = 0; };

        try
        {
          this.IDComentarioComprador = Int32.Parse(r["idcomentariocomprador"].ToString());
        }
        catch { this.IDComentarioComprador = 0; };        
        try
        {
          this.IDComentarioVendedor = Int32.Parse(r["idcomentariovendedor"].ToString());
        }
        catch { this.IDComentarioVendedor = 0; };

        return true;
      }

      public bool CargaConCodigo(int intID)
      {
        return CargaConCodigo(intID.ToString());
      }

      #endregion

      public int Borrar()
      {
        // Ya crea el objeto sqlInsertCMD
        DeleteCMD = "DELETE FROM comentario WHERE idcomentario=@idcomentario";

        sqlDeleteCMD.Parameters.Add("@idcomentario", SqlDbType.Int).Value = this.IDComentario;

        return BorraCampos();
      }

      public int CrearComentario()
      {
        if (Existe(this.IDSubasta.ToString()))
          return Updatear();
        else
          return Insertar();
      }


      public int Insertar()
      {

        // Ya crea el objeto sqlInsertCMD
        InsertCMD = "INSERT INTO comentario (idsubasta,idcomentariocomprador,idcomentariovendedor)"
          + " VALUES (@idsubasta,@idcomentariocomprador,@idcomentariovendedor)";

        sqlInsertCMD.Parameters.Add("@idsubasta", SqlDbType.Int).Value = this.IDSubasta;
        sqlInsertCMD.Parameters.Add("@idcomentariocomprador", SqlDbType.Int).Value = this.IDComentarioComprador;
        sqlInsertCMD.Parameters.Add("@idcomentariovendedor", SqlDbType.Int).Value = this.IDComentarioVendedor;

        return InsertaCampos();
      }

      public int Updatear()
      {

        if (this.IDComentarioComprador == null || this.IDComentarioComprador == 0)
        {
          UpdateCMD = "UPDATE comentario SET idcomentariovendedor=@idcomentariovendedor "
          + " WHERE idsubasta=@idsubasta";

          sqlUpdateCMD.Parameters.Add("@idsubasta", SqlDbType.Int).Value = this.IDSubasta;
          sqlUpdateCMD.Parameters.Add("@idcomentariovendedor", SqlDbType.Int).Value = this.IDComentarioVendedor;
        }
        else
        {
          UpdateCMD = "UPDATE comentario SET idcomentariocomprador=@idcomentariocomprador "
          + " WHERE idsubasta=@idsubasta";

          sqlUpdateCMD.Parameters.Add("@idsubasta", SqlDbType.Int).Value = this.IDSubasta;
          sqlUpdateCMD.Parameters.Add("@idcomentariocomprador", SqlDbType.Int).Value = this.IDComentarioComprador;
        }



        return ActualizaCampos();
      }

   }


     ///+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
   /// 
   /// Clase TTotalComentario
   /// 
   ///+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
   public class TTotalComentario : TBaseBBDD
   {
     private int intTotalPositivo;
     private int intTotalNeutro;
     private int intTotalNegativo;

     public int TotalPositivo { get { return intTotalPositivo; } set { intTotalPositivo = value; } }
     public int TotalNeutro { get { return intTotalNeutro; } set { intTotalNeutro = value; } }
     public int TotalNegativo { get { return intTotalNegativo; } set { intTotalNegativo = value; } }

     public TTotalComentario()
     {
     }


     public int ConsultarComentarios(int intID)
     {

        int intResultado;
        System.Data.SqlClient.SqlParameter[] parms = new System.Data.SqlClient.SqlParameter[4];
        parms[0] = new System.Data.SqlClient.SqlParameter("@IdUsuario", System.Data.SqlDbType.Int);
        parms[0].Value = intID;
        parms[1] = new System.Data.SqlClient.SqlParameter("@totalpositivos", System.Data.SqlDbType.Int);
        parms[1].Value = 0;
        parms[1].Direction = ParameterDirection.InputOutput;
        parms[2] = new System.Data.SqlClient.SqlParameter("@totalneutros", System.Data.SqlDbType.Int);
        parms[2].Value = 0;
        parms[2].Direction = ParameterDirection.InputOutput;
        parms[3] = new System.Data.SqlClient.SqlParameter("@totalnegativos", System.Data.SqlDbType.Int);
        parms[3].Value = 0;
        parms[3].Direction = ParameterDirection.InputOutput;
       
         
        ProcedureCMD("ConsultarComentarios", ref parms);

        try
        {
          string strResultado = parms[1].Value.ToString();
          Int32.TryParse(strResultado, out intResultado);
          this.TotalPositivo=intResultado;
          strResultado = parms[2].Value.ToString();
          Int32.TryParse(strResultado, out intResultado);
          this.TotalNeutro=intResultado;
          strResultado = parms[3].Value.ToString();
          Int32.TryParse(strResultado, out intResultado);
          this.TotalNegativo=intResultado;
        }
        catch (Exception)
        {
          intResultado = -1;
        }

        return intResultado;

      
     }


   }


   ///+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
   /// 
   /// Clase TCategoria 
   /// 
   ///+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
   public class TCategoria : TBaseBBDD, TiBBDD
   {
      private int intIDCategoria;
      private string strNombre;

      public int IDCategoria { get { return intIDCategoria; } set { intIDCategoria = value; } }
      public string Nombre { get { return strNombre; } set { strNombre = value; } }

      public TCategoria()
      {
      }

      public bool CargaDataRowEnObjeto(DataRow r)
     {

       try
       {
         this.IDCategoria = Int32.Parse(r["IDCategoria"].ToString());
       }
       catch { this.IDCategoria = 0; };

       this.Nombre = r["nombre"].ToString();

       return true;
     }

      #region Miembros de TiBBDD

      public bool CargaConCodigo(string strCodigo)
      {
         DataTable tblAgencia;

         SelectCMD = "select * from categoria where idcategoria="+strCodigo;

         tblAgencia = DevuelveTabla();

         if (tblAgencia.Rows.Count > 0)
         {
           CargaDataRowEnObjeto(tblAgencia.Rows[0]);
            return true;
         }
         else
            return false;
      }

      public bool CargaConCodigo(int intID)
      {
        return CargaConCodigo(intID.ToString());
      }

      public DataSet CargaDataSet()
      {
        SelectCMD = "select 0 as idcategoria,'Todas' as nombre union SELECT idcategoria,nombre from categoria";
         return DevuelveDataSet();
      }

      #endregion

      public int Borrar()
      {
        DeleteCMD = "DELETE FROM categoria WHERE idcategoria=@idcategoria";

        sqlDeleteCMD.Parameters.Add("@idcategoria", SqlDbType.Int).Value = this.IDCategoria;

        return BorraCampos();
      }


      public int Insertar()
      {

        // Ya crea el objeto sqlInsertCMD
        InsertCMD = "INSERT INTO categoria (nombre)"
          + " VALUES (@nombre)";

        sqlInsertCMD.Parameters.Add("@nombre", SqlDbType.VarChar,200).Value = this.Nombre;

        return InsertaCampos();
      }

      public int Updatear()
      {

        UpdateCMD = "UPDATE categoria SET nombre=@nombre "
        + " WHERE idcategoria=@idcategoria";

        sqlUpdateCMD.Parameters.Add("@idcategoria", SqlDbType.Int).Value = this.IDCategoria;
        sqlUpdateCMD.Parameters.Add("@nombre", SqlDbType.VarChar,200).Value = this.Nombre;

        return ActualizaCampos();
      }

   }


   ///+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
   /// 
   /// Clase TSubasta
   /// 
   ///+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
   public class TSubasta : TBaseBBDD, TiBBDD
   {
      private int intIDSubasta;
      private int intIDArticulo;
      private int intIDVendedor;
      private int intIDComprador;
      private int intIDEstado;
      private DateTime dtiFechaInicio;
      private DateTime dtiFechaFin;
      private double fltPrecioActual;
      private double fltPrecioInicial;
      private double fltPrecioComprarAhora;
      private int intNumeroPujas;
      private TArticulo objArticulo;
      private TUsuario objVendedor;
      private TUsuario objComprador;

      public int IDSubasta { get { return intIDSubasta; } set { intIDSubasta = value; } }
      public int IDArticulo { get { return intIDArticulo; } set { intIDArticulo = value; } }
      public int IDVendedor { get { return intIDVendedor; } set { intIDVendedor = value; } }
      public int IDComprador { get { return intIDComprador; } set { intIDComprador = value; } }
      public int IDEstado { get { return intIDEstado; } set { intIDEstado = value; } }
      public DateTime FechaInicio { get { return dtiFechaInicio; } set { dtiFechaInicio = value; } }
      public DateTime FechaFin { get { return dtiFechaFin; } set { dtiFechaFin = value; } }
      public double PrecioActual { get { return fltPrecioActual; } set { fltPrecioActual = value; } }
      public double PrecioInicial { get { return fltPrecioInicial; } set { fltPrecioInicial = value; } }
      public double PrecioComprarAhora { get { return fltPrecioComprarAhora; } set { fltPrecioComprarAhora = value; } }
      public int NumeroPujas { get { return intNumeroPujas; } set { intNumeroPujas = value; } }
      public TArticulo Articulo { get { return objArticulo; } set { objArticulo = value; } }
      public TUsuario Vendedor { get { return objVendedor; } set { objVendedor = value; } }
      public TUsuario Comprador { get { return objComprador; } set { objComprador = value; } }

      public TSubasta()
      {
        objArticulo = new TArticulo();
        objVendedor = new TUsuario();
        objComprador = new TUsuario();
      }
 

      #region Miembros de TiBBDD

      public virtual bool CargaDataRowEnObjeto(DataRow r)
      {
        try
        {

          if (!r.IsNull("IDSubasta"))
          {
       try
       {
         this.IDSubasta = Int32.Parse(r["IDSubasta"].ToString());
       }
       catch { this.IDSubasta = 0; };
       try
       {
         this.IDArticulo = Int32.Parse(r["IDArticulo"].ToString());

         objArticulo.CargaConCodigo(this.IDArticulo);

       }
       catch { this.IDArticulo = 0; };
       try
       {
         this.IDVendedor = Int32.Parse(r["IDVendedor"].ToString());

         objVendedor.CargaConCodigo(this.IDVendedor);
       }
       catch { this.IDVendedor = 0; };
       try
       {
         this.IDComprador = Int32.Parse(r["IDComprador"].ToString());

         if (this.IDComprador > 0)
           objComprador.CargaConCodigo(this.IDComprador);
       }
       catch { this.IDComprador = 0; };            
       try
       {
         this.IDEstado = Int32.Parse(r["IDEstado"].ToString());
       }
       catch { this.IDEstado = 0; };            
      
            if (!r.IsNull("FechaInicio"))
            {
              this.FechaInicio = DateTime.Parse(r["FechaInicio"].ToString());
            }
            else this.FechaInicio = DateTime.MinValue;
            if (!r.IsNull("FechaFin"))
            {
              this.FechaFin = DateTime.Parse(r["FechaFin"].ToString());
            }
            else this.FechaFin = DateTime.MinValue;

       try
       {
         this.PrecioActual = Double.Parse(r["PrecioActual"].ToString());
       }
       catch { this.PrecioActual = 0; };  
       try
       {
         this.PrecioInicial = Double.Parse(r["PrecioInicial"].ToString());
       }
       catch { this.PrecioInicial = 0; };  
       try
       {
         this.PrecioComprarAhora = Double.Parse(r["PrecioCompraAhora"].ToString());
       }
       catch { this.PrecioComprarAhora = 0; };  
      try
       {
         this.NumeroPujas = Int32.Parse(r["NumeroPujas"].ToString());
       }
       catch { this.NumeroPujas = 0; };            

            return true;
          }
          else return false;
        }
        catch
        {
          return false;
        }
      }


      public virtual bool CargaConCodigo(string strCodigo)
      {
         DataTable tabla;

         SelectCMD = "select TOP 1 * from subasta where idsubasta=" + strCodigo; 

         tabla = DevuelveTabla();

         if (tabla.Rows.Count > 0)
         {
            return CargaDataRowEnObjeto(tabla.Rows[0]);
         }
         else
            return false;
      }

      public virtual bool CargaConCodigo(int intID)
      {
        return CargaConCodigo(intID.ToString());
      }

      public virtual DataSet CargaDataSet()
      {
         SelectCMD = "select * from subasta where fechafin>=getdate()";
         return DevuelveDataSet();
      }

      #endregion

      public virtual DataSet DimeSubastasActivas(int intIDCategoria)
      {
        //string strFechaAhora;
        
        //strFechaAhora = "'" + DateTime.Now.Day.ToString() + "/" + DateTime.Now.Month.ToString() + "/" + DateTime.Now.Year.ToString() + " "+DateTime.Now.Hour.ToString() + ":"+DateTime.Now.Minute.ToString() + ":"+DateTime.Now.Second.ToString() + "'";

        SelectCMD = "select s.IDSubasta,a.Nombre,s.precioactual,s.preciocompraahora,s.fechafin "+
        " from subasta s inner join Articulo a on s.IDArticulo=a.idarticulo "+
        " inner join Categoria c on c.idcategoria=a.idcategoria " +
        " where s.fechafin>=getdate() and s.idestado=2";

        if (intIDCategoria > 0)
          SelectCMD += " and c.idcategoria=" + intIDCategoria.ToString();

        return DevuelveDataSet();
      }

      public virtual DataSet DimeMisSubastasFinalizadas(int intIDCategoria, int intIDUsuario)
      {
        SelectCMD = "select s.IDSubasta,a.Nombre,s.precioactual,s.preciocompraahora,s.fechafin " +
        " from subasta s inner join Articulo a on s.IDArticulo=a.idarticulo " +
        " inner join Categoria c on c.idcategoria=a.idcategoria " +
        " where s.idestado=3 and (Idcomprador="+intIDUsuario.ToString()+" or idvendedor="+intIDUsuario.ToString()+")";

        if (intIDCategoria > 0)
          SelectCMD += " and c.idcategoria=" + intIDCategoria.ToString();

        return DevuelveDataSet();
      }


      public virtual DataSet DimeSubastasActivas(string strNombre)
      {
        //string strFechaAhora;

        //strFechaAhora = "'" + DateTime.Now.Day.ToString() + "/" + DateTime.Now.Month.ToString() + "/" + DateTime.Now.Year.ToString() + " "+DateTime.Now.Hour.ToString() + ":"+DateTime.Now.Minute.ToString() + ":"+DateTime.Now.Second.ToString() + "'";

        SelectCMD = "select s.IDSubasta,a.Nombre,s.precioactual,s.preciocompraahora,s.fechafin " +
        " from subasta s inner join Articulo a on s.IDArticulo=a.idarticulo " +
        " where s.fechafin>=getdate() and s.idestado=2 and a.nombre like '" + strNombre+"%'";

        return DevuelveDataSet();

      }

      public virtual TSubasta DimeSubasta(int intIDSubasta)
      {
        this.CargaConCodigo(intIDSubasta);

        return this;

      }


      public virtual DataSet DimeSubastasFinalizadas()
      {
        SelectCMD = "select s.IDSubasta,a.Nombre,s.precioactual,s.preciocompraahora,s.fechafin " +
        " from subasta s inner join Articulo a on s.IDArticulo=a.idarticulo " +
        " where s.fechafin<getdate() and s.idestado=3";
        return DevuelveDataSet();
      }


      public int Borrar()
      {
        DeleteCMD = "DELETE FROM subasta WHERE idsubasta=@idsubasta";

        sqlDeleteCMD.Parameters.Add("@idsubasta", SqlDbType.Int).Value = this.IDSubasta;

        return BorraCampos();
      }


      public int Insertar()
      {
        int intArticuloID=this.Articulo.Insertar();
        if (intArticuloID > 0)
        {

          InsertCMD = "INSERT INTO subasta (idarticulo,idvendedor,idestado,fechainicio,fechafin,precioactual,precioinicial,preciocompraahora,numeropujas)"
            + " VALUES (@idarticulo,@idvendedor,@idestado,@fechainicio,@fechafin,@precioactual,@precioinicial,@preciocompraahora,@numeropujas)";

          sqlInsertCMD.Parameters.Add("@idarticulo", SqlDbType.Int).Value = intArticuloID;
          sqlInsertCMD.Parameters.Add("@idvendedor", SqlDbType.Int).Value = this.IDVendedor;
          sqlInsertCMD.Parameters.Add("@idestado", SqlDbType.Int).Value = 2;
          sqlInsertCMD.Parameters.Add("@fechainicio", SqlDbType.DateTime).Value = DateTime.Now;
          if (this.FechaFin == DateTime.MinValue)
            sqlInsertCMD.Parameters.Add("@fechafin", SqlDbType.DateTime).Value = DBNull.Value;
          else
            sqlInsertCMD.Parameters.Add("@fechafin", SqlDbType.DateTime).Value = this.FechaFin;
          sqlInsertCMD.Parameters.Add("@precioactual", SqlDbType.Money).Value = this.PrecioInicial;
          sqlInsertCMD.Parameters.Add("@precioinicial", SqlDbType.Money).Value = this.PrecioInicial;
          sqlInsertCMD.Parameters.Add("@preciocompraahora", SqlDbType.Money).Value = this.PrecioComprarAhora;
          sqlInsertCMD.Parameters.Add("@numeropujas", SqlDbType.Int).Value = 0;

          if (InsertaCampos() > 0)
            return intArticuloID;
          else
            return -1;  //error en la inserccin
        }
        else
          return -1;  //error en la inserccin


      }

      public int Updatear()
      {

        UpdateCMD = "UPDATE articulo SET idarticulo=@idarticulo,idvendedor=@idvendedor,idestado=@idestado,fechainicio=@fechainicio,fechafin=@fechafin,precioactual=@precioactual,precioinicial=@precioinicial,preciocompraahora=@preciocompraahora,numeropujas=@numeropujas "
        + " WHERE idsubasta=@idsubasta";


        sqlUpdateCMD.Parameters.Add("@idarticulo", SqlDbType.Int).Value = this.IDArticulo;
        sqlUpdateCMD.Parameters.Add("@idvendedor", SqlDbType.Int).Value = this.IDVendedor;
        sqlUpdateCMD.Parameters.Add("@idestado", SqlDbType.Int).Value = this.IDEstado;
        if (this.FechaInicio == DateTime.MinValue)
          sqlUpdateCMD.Parameters.Add("@fechainicio", SqlDbType.DateTime).Value = DBNull.Value;
        else
          sqlUpdateCMD.Parameters.Add("@fechainicio", SqlDbType.DateTime).Value = this.FechaInicio;
        if (this.FechaFin == DateTime.MinValue)
          sqlUpdateCMD.Parameters.Add("@fechafin", SqlDbType.DateTime).Value = DBNull.Value;
        else
          sqlUpdateCMD.Parameters.Add("@fechafin", SqlDbType.DateTime).Value = this.FechaFin;
        sqlUpdateCMD.Parameters.Add("@precioactual", SqlDbType.Money).Value = this.PrecioActual;
        sqlUpdateCMD.Parameters.Add("@precioinicial", SqlDbType.Money).Value = this.PrecioInicial;
        sqlUpdateCMD.Parameters.Add("@preciocompraahora", SqlDbType.Money).Value = this.PrecioComprarAhora;
        sqlUpdateCMD.Parameters.Add("@numeropujas", SqlDbType.Int).Value = this.NumeroPujas;
        sqlUpdateCMD.Parameters.Add("@idsubasta", SqlDbType.Int).Value = this.IDSubasta;

        return ActualizaCampos();
      }

      public int ComprarAhora()
      {
        int intResultado;
        System.Data.SqlClient.SqlParameter[] parms = new System.Data.SqlClient.SqlParameter[3];
        parms[0] = new System.Data.SqlClient.SqlParameter("@IdSubasta", System.Data.SqlDbType.Int);
        parms[0].Value = this.IDSubasta;
        parms[1] = new System.Data.SqlClient.SqlParameter("@IdComprador", System.Data.SqlDbType.Int);
        parms[1].Value = this.IDComprador;
        parms[2] = new System.Data.SqlClient.SqlParameter("@intCode", System.Data.SqlDbType.Int);
        parms[2].Value = 0;
        parms[2].Direction = ParameterDirection.InputOutput;

        ProcedureCMD("ComprarAhora", ref parms);

        try
        {
          string strResultado = parms[2].Value.ToString();
          Int32.TryParse(strResultado, out intResultado);
        }
        catch (Exception)
        {
          intResultado = -1;
        }

        return intResultado;

      }

   }


   ///+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
   /// 
   /// Clase TTipoComentario 
   /// 
   ///+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
   public class TTipoComentario : TBaseBBDD, TiBBDD
   {
      private int intIDTipoComentario;
      private string strNombre;

      public int IDTipoComentario { get { return intIDTipoComentario; } set { intIDTipoComentario = value; } }
      public string Nombre { get { return strNombre; } set { strNombre = value; } }

      public TTipoComentario()
      {
      }


      #region Miembros de TiBBDD

      public bool CargaConCodigo(int intCodigo)
      {
        return CargaConCodigo(intCodigo.ToString());
      }

      public bool CargaConCodigo(string strCodigo)
      {
         DataTable tblTemp;

         SelectCMD = "select * from tipocomentario";

         tblTemp = DevuelveTabla();

         if (tblTemp.Rows.Count > 0)
         {
           return CargaDataRowEnObjeto(tblTemp.Rows[0]);
         }
         else
            return false;
      }

  
      public DataSet CargaDataSet()
      {
         SelectCMD = "select * from tipocomentario";
         return DevuelveDataSet();
      }



      public bool CargaDataRowEnObjeto(DataRow r)
      {

        try
        {
          this.IDTipoComentario = Int32.Parse(r["IDTipoComentario"].ToString());
        }
        catch { this.IDTipoComentario = 0; };

        this.Nombre = r["Nombre"].ToString();

         return true;
      }

      #endregion

      public int Borrar()
      {
        DeleteCMD = "DELETE FROM tipocomentario WHERE idtipocomentario=@idtipocomentario";

        sqlDeleteCMD.Parameters.Add("@idtipocomentario", SqlDbType.Int).Value = this.IDTipoComentario;

        return BorraCampos();
      }


      public int Insertar()
      {

        InsertCMD = "INSERT INTO tipocomentario (nombre)"
          + " VALUES (@nombre)";

        sqlInsertCMD.Parameters.Add("@nombre", SqlDbType.VarChar, 200).Value = this.Nombre;

        return InsertaCampos();
      }

      public int Updatear()
      {

        UpdateCMD = "UPDATE tipocomentario SET nombre=@nombre "
        + " WHERE idtipocomentario=@idtipocomentario";

        sqlUpdateCMD.Parameters.Add("@idtipocomentario", SqlDbType.Int).Value = this.IDTipoComentario;
        sqlUpdateCMD.Parameters.Add("@nombre", SqlDbType.VarChar, 200).Value = this.Nombre;

        return ActualizaCampos();
      }


   }

   ///+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
   /// 
   /// Clase TPuja 
   /// 
   ///+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
   public class TPuja : TBaseBBDD, TiBBDD
   {
      private int intIDPuja;
      private int intIDSubasta;
      private double fltPrecioPuja;
      private DateTime dtiFechaPuja;
      private int intIDComprador;
      private int intIDUsuario;

      public int IDPuja { get { return intIDPuja; } set { intIDPuja = value; } }
      public int IDSubasta { get { return intIDSubasta; } set { intIDSubasta = value; } }
      public double PrecioPuja { get { return fltPrecioPuja; } set { fltPrecioPuja = value; } }
      public DateTime FechaPuja { get { return dtiFechaPuja; } set { dtiFechaPuja = value; } }
      public int IDComprador { get { return intIDComprador; } set { intIDComprador = value; } }
      public int IDUsuario { get { return intIDUsuario; } set { intIDUsuario = value; } }

      public TPuja()
      {
      }


      public DataSet ConsultarPujas(int intSubasta)
      {
        SelectCMD = "select nickname,PrecioPuja,FechaPuja from puja p left join Usuario u on p.IDComprador=u.idusuario where idsubasta="+intSubasta.ToString()+ " order by FechaPuja desc";
    
        return DevuelveDataSet();
      }


      #region Miembros de TiBBDD


      public bool CargaConCodigo(int intCodigo)
      {
        return CargaConCodigo(intCodigo.ToString());
      }


      public bool CargaConCodigo(string strCodigo)
      {
         DataTable tblTemp;

         tblTemp = DevuelveTabla();

         if (tblTemp.Rows.Count > 0)
         {
           return CargaDataRowEnObjeto(tblTemp.Rows[0]);
         }
         else
            return false;
      }

      public DataSet CargaDataSet()
      {
         SelectCMD = "select * from puja";
         return DevuelveDataSet();
      }

       public bool CargaDataRowEnObjeto(DataRow r)
      {

       try
       {
         this.IDPuja = Int32.Parse(r["IDPuja"].ToString());
       }
       catch { this.IDPuja = 0; };            
      try
       {
         this.IDSubasta = Int32.Parse(r["IDSubasta"].ToString());
       }
       catch { this.IDSubasta = 0; }; 
         try
       {
         this.PrecioPuja = Double.Parse(r["PrecioPuja"].ToString());
       }
       catch { this.PrecioPuja = 0; }; 
         try
       {
         this.IDComprador = Int32.Parse(r["IDComprador"].ToString());
       }
       catch { this.IDComprador = 0; }; 
         try
       {
         this.IDUsuario = Int32.Parse(r["IDUsuario"].ToString());
       }
       catch { this.IDUsuario = 0; }; 

            if (!r.IsNull("FechaPuja"))
            {
              this.FechaPuja = DateTime.Parse(r["FechaPuja"].ToString());
            }
            else this.FechaPuja = DateTime.MinValue;
         return true;
      }

      #endregion

       public int Borrar()
       {
         DeleteCMD = "DELETE FROM puja WHERE idpuja=@idpuja";

         sqlDeleteCMD.Parameters.Add("@idpuja", SqlDbType.Int).Value = this.IDPuja;

         return BorraCampos();
       }


       public int Insertar()
       {

         int intResultado;
         System.Data.SqlClient.SqlParameter[] parms = new System.Data.SqlClient.SqlParameter[4];
         parms[0] = new System.Data.SqlClient.SqlParameter("@IdSubasta", System.Data.SqlDbType.Int);
         parms[0].Value = this.IDSubasta;
         parms[1] = new System.Data.SqlClient.SqlParameter("@IdComprador", System.Data.SqlDbType.Int);
         parms[1].Value = this.IDComprador;
         parms[2] = new System.Data.SqlClient.SqlParameter("@preciopuja", System.Data.SqlDbType.Int);
         parms[2].Value = this.PrecioPuja;
         parms[3] = new System.Data.SqlClient.SqlParameter("@intCode", System.Data.SqlDbType.Int);
         parms[3].Value = 0;
         parms[3].Direction = ParameterDirection.InputOutput;

         ProcedureCMD("RealizarPuja", ref parms);

         try
         {
           string strResultado = parms[3].Value.ToString();
           Int32.TryParse(strResultado, out intResultado);
         }
         catch (Exception)
         {
           intResultado = -1;
         }

         return intResultado;


       }

       public int Updatear()
       {

         UpdateCMD = "UPDATE puja SET idsubasta=@idsubasta,preciopuja=@preciopuja,fechapuja=@fechapuja,idcomprador=@idcomprador,idusuario=@idusuario "
         + " WHERE idpuja=@idpuja";

         sqlUpdateCMD.Parameters.Add("@idpuja", SqlDbType.Int).Value = this.IDPuja;
         sqlUpdateCMD.Parameters.Add("@idsubasta", SqlDbType.Int).Value = this.IDSubasta;
         sqlUpdateCMD.Parameters.Add("@preciopuja", SqlDbType.Money).Value = this.PrecioPuja;
         sqlUpdateCMD.Parameters.Add("@fechapuja", SqlDbType.DateTime).Value = DateTime.Now;
         sqlUpdateCMD.Parameters.Add("@idcomprador", SqlDbType.Int).Value = this.IDComprador;
         sqlUpdateCMD.Parameters.Add("@idusuario", SqlDbType.Int).Value = this.IDUsuario;


         return ActualizaCampos();
       }


   }


     ///+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
   /// 
   /// Clase TEstado 
   /// 
   ///+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
   public class TEstado : TBaseBBDD, TiBBDD
   {
      private int intIDEstado;
      private string strNombre;

      public int IDEstado { get { return intIDEstado; } set { intIDEstado = value; } }
      public string Nombre { get { return strNombre; } set { strNombre = value; } }

      public TEstado()
      {
      }

      #region Miembros de TiBBDD

      public bool CargaConCodigo(int intCodigo)
      {
        return CargaConCodigo(intCodigo.ToString());
      }

      public bool CargaConCodigo(string strCodigo)
      {
         DataTable tblTemp;

         SelectCMD = "select * from estado";

         tblTemp = DevuelveTabla();

         if (tblTemp.Rows.Count > 0)
         {
           return CargaDataRowEnObjeto(tblTemp.Rows[0]);
         }
         else
            return false;
      }

  
      public DataSet CargaDataSet()
      {
         SelectCMD = "select * from estado";
         return DevuelveDataSet();
      }



      public bool CargaDataRowEnObjeto(DataRow r)
      {

        try
        {
          this.IDEstado = Int32.Parse(r["IDEstado"].ToString());
        }
        catch { this.IDEstado = 0; };

        this.Nombre = r["Nombre"].ToString();

         return true;
      }

      #endregion


      public int Borrar()
      {
        DeleteCMD = "DELETE FROM estado WHERE idestado=@idestado";

        sqlDeleteCMD.Parameters.Add("@idestado", SqlDbType.Int).Value = this.IDEstado;

        return BorraCampos();
      }


      public int Insertar()
      {

        InsertCMD = "INSERT INTO estado (nombre)"
          + " VALUES (@nombre)";

        sqlInsertCMD.Parameters.Add("@nombre", SqlDbType.VarChar,200).Value = this.Nombre;

        return InsertaCampos();
      }

      public int Updatear()
      {

        UpdateCMD = "UPDATE estado SET nombre=@nombre "
        + " WHERE IDEstado=@IDEstado";

        sqlUpdateCMD.Parameters.Add("@nombre", SqlDbType.VarChar,200).Value = this.Nombre;
        sqlUpdateCMD.Parameters.Add("@IDEstado", SqlDbType.Int).Value = this.IDEstado;

        return ActualizaCampos();
      }


   }

  
     ///+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
   /// 
   /// Clase TUsuario 
   /// 
   ///+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
   public class TUsuario : TBaseBBDD, TiBBDD
   {
      private int intIDUsuario;
      private string strNombre;
      private string strNickName;
      private string strPassword;
      private string strDireccion;
      private string strPoblacion;
      private string strCodigoPostal;
      private string strProvincia;
      private string strPais;
      private string strEmail;
      private string strTelefonoMovil;
      private string strTarjetaCredito;
      private string strCaducidadTarjetaCredito;
      private DateTime dtiFechaIngreso;
      private int intPorcentajeVendedor;
      private int intPorcentajeComprador;
      private string strToken;

      public int IDUsuario { get { return intIDUsuario; } set { intIDUsuario = value; } }
      public string Nombre { get { return strNombre; } set { strNombre = value; } }
      public string NickName { get { return strNickName; } set { strNickName = value; } }
      public string Password { get { return strPassword; } set { strPassword = value; } }
      public string Direccion { get { return strDireccion; } set { strDireccion = value; } }
      public string Poblacion { get { return strPoblacion; } set { strPoblacion = value; } }
      public string CodigoPostal { get { return strCodigoPostal; } set { strCodigoPostal = value; } }
      public string Provincia { get { return strProvincia; } set { strProvincia = value; } }
      public string Pais { get { return strPais; } set { strPais = value; } }
      public string Email { get { return strEmail; } set { strEmail = value; } }
      public string TelefonoMovil { get { return strTelefonoMovil; } set { strTelefonoMovil = value; } }
      public string TarjetaCredito { get { return strTarjetaCredito; } set { strTarjetaCredito = value; } }
      public string CaducidadTarjetaCredito { get { return strCaducidadTarjetaCredito; } set { strCaducidadTarjetaCredito = value; } }
      public DateTime FechaIngreso { get { return dtiFechaIngreso; } set { dtiFechaIngreso = value; } }
      public int PorcentajeVendedor { get { return intPorcentajeVendedor; } set { intPorcentajeVendedor = value; } }
      public int PorcentajeComprador { get { return intPorcentajeComprador; } set { intPorcentajeComprador = value; } }
      public string Token { get { return strToken; } set { strToken = value; } }

      public TUsuario()
      {
      }

      #region Miembros de TiBBDD

      public bool CargaConCodigo(int intCodigo)
      {
        return CargaConCodigo(intCodigo.ToString());
      }


      public bool CargaConCodigo(string strCodigo)
      {
         DataTable tblTemp;

         SelectCMD = "select * from usuario where idusuario="+strCodigo;

         tblTemp = DevuelveTabla();

         if (tblTemp.Rows.Count > 0)
         {
           return CargaDataRowEnObjeto(tblTemp.Rows[0]);
         }
         else
            return false;
      }

      public bool Validar(string strUsuario, string strPassword)
      {
        DataTable tblTemp;

        SelectCMD = "select * from usuario where nickname='"+strUsuario+"' and password='"+strPassword+"'";

        tblTemp = DevuelveTabla();

        if (tblTemp.Rows.Count > 0)
        {
          return CargaDataRowEnObjeto(tblTemp.Rows[0]);
        }
        else
          return false;
      }


      public DataSet CargaDataSet()
      {
         SelectCMD = "select * from usuario";
         return DevuelveDataSet();
      }


      public bool CargaDataRowEnObjeto(DataRow r)
      {
        try
        {

          try
          {
            this.IDUsuario = Int32.Parse(r["IDUsuario"].ToString());
          }
          catch { this.IDUsuario = 0; };
          this.Nombre = r["Nombre"].ToString();
          this.NickName = r["NickName"].ToString();
          this.Password = r["Password"].ToString();
          this.Direccion = r["Direccion"].ToString();
          this.Poblacion = r["Poblacion"].ToString();
          this.CodigoPostal = r["CodigoPostal"].ToString();
          this.Provincia = r["Provincia"].ToString();
          this.Pais = r["Pais"].ToString();
          this.Email = r["Email"].ToString();
          this.TelefonoMovil = r["TelefonoMovil"].ToString();
          this.TarjetaCredito = r["TarjetaCredito"].ToString();
          this.CaducidadTarjetaCredito = r["CaducidadTarjetaCredito"].ToString();
          if (!r.IsNull("FechaIngreso"))
          {
            this.FechaIngreso = DateTime.Parse(r["FechaIngreso"].ToString());
          }
          else this.FechaIngreso = DateTime.MinValue;

          CalcularPorcentaje();

          return true;
        }
        catch
        {
          return false;
        }


      }

      #endregion

      public void CalcularPorcentaje()
      {
        int intResultado;
        System.Data.SqlClient.SqlParameter[] parms = new System.Data.SqlClient.SqlParameter[3];
        parms[0] = new System.Data.SqlClient.SqlParameter("@IdUsuario", System.Data.SqlDbType.Int);
        parms[0].Value = this.IDUsuario;
        parms[1] = new System.Data.SqlClient.SqlParameter("@intPorcentaje", System.Data.SqlDbType.Int);
        parms[1].Value = 0;
        parms[1].Direction = ParameterDirection.InputOutput;
        parms[2] = new System.Data.SqlClient.SqlParameter("@intPorcentajeComprador", System.Data.SqlDbType.Int);
        parms[2].Value = 0;
        parms[2].Direction = ParameterDirection.InputOutput;

        ProcedureCMD("CalcularPorcentaje", ref parms);

        try
        {
          string strResultado = parms[1].Value.ToString();
          Int32.TryParse(strResultado, out intResultado);
          this.PorcentajeVendedor = intResultado;
          strResultado = parms[2].Value.ToString();
          Int32.TryParse(strResultado, out intResultado);
          this.PorcentajeComprador = intResultado;
        }
        catch (Exception)
        {
          this.PorcentajeComprador = 0;
          this.PorcentajeVendedor=0;
        }

      }


      public int Borrar()
      {
        DeleteCMD = "DELETE FROM usuario WHERE idusuario=@idusuario";

        sqlDeleteCMD.Parameters.Add("@idusuario", SqlDbType.Int).Value = this.IDUsuario;

        return BorraCampos();
      }


      public int Insertar()
      {

        InsertCMD = "INSERT INTO usuario (nickname,password,nombre,direccion,poblacion,Pais,CodigoPostal,Provincia,Email,TelefonoMovil,TarjetaCredito,CaducidadTarjetaCredito,FechaIngreso)"
          + " VALUES (@nickname,@password,@nombre,@direccion,@poblacion,@Pais,@CodigoPostal,@Provincia,@Email,@TelefonoMovil,@TarjetaCredito,@CaducidadTarjetaCredito,getdate())";

        sqlInsertCMD.Parameters.Add("@nickname", SqlDbType.VarChar, 100).Value = this.NickName;
        sqlInsertCMD.Parameters.Add("@password", SqlDbType.VarChar, 100).Value = this.Password;
        sqlInsertCMD.Parameters.Add("@nombre", SqlDbType.VarChar, 200).Value = this.Nombre;
        sqlInsertCMD.Parameters.Add("@direccion", SqlDbType.VarChar, 200).Value = this.Direccion;
        sqlInsertCMD.Parameters.Add("@poblacion", SqlDbType.VarChar, 200).Value = this.Poblacion;
        sqlInsertCMD.Parameters.Add("@Pais", SqlDbType.VarChar, 100).Value = this.Pais;
        sqlInsertCMD.Parameters.Add("@CodigoPostal", SqlDbType.VarChar, 10).Value = this.CodigoPostal;
        sqlInsertCMD.Parameters.Add("@Provincia", SqlDbType.VarChar, 100).Value = this.Provincia;
        sqlInsertCMD.Parameters.Add("@Email", SqlDbType.VarChar, 100).Value = this.Email;
        sqlInsertCMD.Parameters.Add("@TelefonoMovil", SqlDbType.VarChar, 10).Value = this.TelefonoMovil;
        sqlInsertCMD.Parameters.Add("@TarjetaCredito", SqlDbType.VarChar, 50).Value = this.TarjetaCredito;
        sqlInsertCMD.Parameters.Add("@CaducidadTarjetaCredito", SqlDbType.VarChar, 10).Value = this.CaducidadTarjetaCredito;
        sqlInsertCMD.Parameters.Add("@FechaIngreso", SqlDbType.DateTime).Value = DateTime.Now;
        

        return InsertaCampos();
      }

      public int Updatear()
      {

        UpdateCMD = "UPDATE usuario SET nombre=@nombre,direccion=@direccion,poblacion=@poblacion,Pais=@Pais,CodigoPostal=@CodigoPostal,Provincia=@Provincia,Email=@Email,TelefonoMovil=@TelefonoMovil,TarjetaCredito=@TarjetaCredito,CaducidadTarjetaCredito=@CaducidadTarjetaCredito "
        + " WHERE idusuario=@idusuario";

        sqlUpdateCMD.Parameters.Add("@nombre", SqlDbType.VarChar, 200).Value = this.Nombre;
        sqlUpdateCMD.Parameters.Add("@direccion", SqlDbType.VarChar, 200).Value = this.Direccion;
        sqlUpdateCMD.Parameters.Add("@poblacion", SqlDbType.VarChar, 200).Value = this.Poblacion;
        sqlUpdateCMD.Parameters.Add("@Pais", SqlDbType.VarChar, 100).Value = this.Pais;
        sqlUpdateCMD.Parameters.Add("@CodigoPostal", SqlDbType.VarChar, 10).Value = this.CodigoPostal;
        sqlUpdateCMD.Parameters.Add("@Provincia", SqlDbType.VarChar, 100).Value = this.Provincia;
        sqlUpdateCMD.Parameters.Add("@Email", SqlDbType.VarChar, 100).Value = this.Email;
        sqlUpdateCMD.Parameters.Add("@TelefonoMovil", SqlDbType.VarChar, 10).Value = this.TelefonoMovil;
        sqlUpdateCMD.Parameters.Add("@TarjetaCredito", SqlDbType.VarChar, 50).Value = this.TarjetaCredito;
        sqlUpdateCMD.Parameters.Add("@CaducidadTarjetaCredito", SqlDbType.VarChar, 10).Value = this.CaducidadTarjetaCredito;
        sqlUpdateCMD.Parameters.Add("@idusuario", SqlDbType.Int).Value = this.IDUsuario;


        return ActualizaCampos();
      }


   }


}

