using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using System.IO;
using Service1;
using System.Globalization;


public partial class CrearSubasta : System.Web.UI.Page
{
  Service1Client objWCF;
  TUsuario usuario;

  void Page_Load(object sender, EventArgs e)
  {

    if (!Page.IsPostBack)
    {

      usuario = (TUsuario)Session["Usuario"];
      objWCF = (Service1Client)Session["objWCF"];

      if (objWCF == null)
        objWCF = new Service1Client();

      if (usuario != null)
        lblUsuario.Text = "Usuario Validado : " + usuario.NickName;


    }
    else
    {
      objWCF = (Service1Client)Session["objWCF"];
      usuario = (TUsuario)Session["Usuario"];
    }

    if (usuario != null)
    {
      lblUsuario.Text = "Usuario Validado : " + usuario.NickName;
      hblMisSubastas.NavigateUrl = "VerMisSubastas.aspx?IDUsuario=" + usuario.IDUsuario.ToString();
    }
    else
    {
      lblUsuario.Text = "";
      hblMisSubastas.Text = "Validar";
      hblMisSubastas.NavigateUrl = "ValidarUsuario.aspx";
    }


  }

    protected void Page_UnLoad(object sender, EventArgs e)
    {
      Session["objWCF"] = objWCF;
      Session["Usuario"] = usuario;
    }


    protected void btnCrearSubasta_Click(object sender, EventArgs e)
    {
      System.Configuration.AppSettingsReader confSettings = new AppSettingsReader();
      string strDirectorio = ((string)(confSettings.GetValue("PathImagenes", typeof(string)))) + "\\";


      if (FileUpload1.HasFile)
      {
        Label1.Text = "";
        string strExtension = FileUpload1.FileName.Substring(FileUpload1.FileName.LastIndexOf(".") + 1);
        if (strExtension.ToLower() == "jpg" || strExtension.ToLower() == "jpeg")
        {
          try
          {
            FileUpload1.SaveAs(strDirectorio + Session.SessionID.ToString()+".jpg");
            //FileUpload1.SaveAs(strDirectorio + FileUpload1.FileName);
          }
          catch (Exception ex)
          {
            Label1.Text = "ERROR: " + ex.Message.ToString();
          }

          // insertar subasta
          TSubasta objSubasta = new TSubasta();
          objSubasta.Articulo = new TArticulo();

          if ((txtNombreArticulo.Text == "") || (txtDescripcionArticulo.Text == ""))
          {
            Label1.Text = "Debe Nombrar y Describir el Artculo.";
            return;
          }

          objSubasta.Articulo.Nombre = txtNombreArticulo.Text;
          objSubasta.Articulo.Descripcion = txtDescripcionArticulo.Text;

          
          int intCategoria;
          Int32.TryParse(cbxCategorias.SelectedValue.ToString(),out intCategoria);
          if (intCategoria == 0)
          {
            Label1.Text = "Debe seleccionar una categoria.";
            return;
          }

          objSubasta.Articulo.IDCategoria = intCategoria;

          DateTime tmpFechaHora;
          CultureInfo ci = new CultureInfo("es-ES", false);
          DateTime.TryParse(txtFechaFinal.Text, ci, DateTimeStyles.None, out tmpFechaHora);

          objSubasta.FechaFin = tmpFechaHora;

          if (objSubasta.FechaFin <= DateTime.Now)
          {
            Label1.Text = "La fecha final debe ser superior a la actual.";
            return;
          }

          objSubasta.IDVendedor = 1;   //Id del usuario
          double dPrecio;
          Double.TryParse(txtPrecioInicial.Text,out dPrecio);
          objSubasta.PrecioInicial = dPrecio;
          Double.TryParse(txtPrecioComprarAhora.Text, out dPrecio);
          objSubasta.PrecioComprarAhora = dPrecio;

          if ((objSubasta.PrecioComprarAhora>0) &&(objSubasta.PrecioComprarAhora< objSubasta.PrecioInicial))
          {
            Label1.Text = "El precio Comprar Ahora debe ser mayor que el Inicial.";
            return;
          }

          int intResultado=objWCF.CrearSubasta(objSubasta);

          if (intResultado > 0)
          {
            // recuperar ID subasta

            string strID = intResultado.ToString();

            while (strID.Length < 5)
              strID = "0" + strID;

            //renombrar el archivo
            File.Move(strDirectorio + Session.SessionID.ToString() + ".jpg", strDirectorio + strID + ".jpg");

            Response.Redirect("Subastas.aspx");
              

          }
          else
          {
            Label1.Text = "Error al crear la subasta. Revise los datos introducidos.";
          }

        }
        else
          Label1.Text = "El fichero seleccionado no es JPG.";
      }
      else
      {
        Label1.Text = "No ha especificado una imagen.";
      }

    }
    protected void btnCancelar_Click(object sender, EventArgs e)
    {
      Response.Redirect("Subastas.aspx");
    }


}
