using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using System.IO;
using Service1;
using SubastasCli;

public partial class DetalleSubasta : System.Web.UI.Page
{
  Service1Client objWCF;
  TSubasta objSubasta;
  TUsuario usuario;

  private void ObtenerSubastaActual()
  {
    int intSubastaId;

    if (Request.QueryString["SubastaId"] != null && Int32.TryParse((string)Request.QueryString["SubastaId"], out intSubastaId))
    {
      if (intSubastaId > 0)
      {
        objSubasta=objWCF.VerDetalleSubasta(intSubastaId);
      }
    }
  }


  void Page_Load(object sender, EventArgs e)
  {

    if (!Page.IsPostBack)
    {

      usuario = (TUsuario)Session["Usuario"];
      objWCF = (Service1Client)Session["objWCF"];
      objSubasta = (TSubasta)Session["Subasta"];

      if (objWCF == null)
        objWCF = new Service1Client();

      ObtenerSubastaActual();

      
      CargarDatos();


      

    }
    else
    {
      objWCF = (Service1Client)Session["objWCF"];
      usuario = (TUsuario)Session["Usuario"];
      objSubasta = (TSubasta)Session["Subasta"];
    }

    if (usuario != null)
    {
      lblUsuario.Text = "Usuario Validado : " + usuario.NickName;
      hblMisSubastas.NavigateUrl = "VerMisSubastas.aspx?IDUsuario=" + usuario.IDUsuario.ToString();

    }
    else
    {
      lblUsuario.Text = "";
      hblMisSubastas.Text = "Validar";
      hblMisSubastas.NavigateUrl = "ValidarUsuario.aspx";
    }



  }

  private void CargarDatos()
  {
    lblPrecioActual.Text = objSubasta.PrecioActual.ToString();
    lblPrecioComprarAhora.Text =objSubasta.PrecioComprarAhora.ToString();
    lblPrecioSuperior.Text="(Precio debe ser superior a : "+objSubasta.PrecioActual.ToString()+")";
    lblNombre.Text=objSubasta.Articulo.Nombre;
    lblDescripcion.Text=objSubasta.Articulo.Descripcion;
    lblFechaInicio.Text=objSubasta.FechaInicio.ToString("d");
    lblFechaFinal.Text = objSubasta.FechaFin.ToString("d");
 
    hblPujas.Text = objSubasta.NumeroPujas.ToString();
    hblPujas.NavigateUrl = "VerPujas.aspx?IDSubasta=" + objSubasta.IDSubasta.ToString();

    imgArticulo.ImageUrl = objSubasta.Articulo.Imagen;

    hblVendedor.Text = objSubasta.Vendedor.NickName + " (" + objSubasta.Vendedor.PorcentajeVendedor.ToString() + "%)";
    hblVendedor.NavigateUrl = "VerComentarios.aspx?IDUsuario=" + objSubasta.Vendedor.IDUsuario.ToString();

    if ((objSubasta.Comprador.NickName!=null) && (objSubasta.Comprador.NickName != ""))
    {
      hblComprador.Text = objSubasta.Comprador.NickName + " (" + objSubasta.Comprador.PorcentajeComprador.ToString() + "%)";
      hblComprador.NavigateUrl = "VerComentarios.aspx?IDUsuario=" + objSubasta.Comprador.IDUsuario.ToString();
    }
    else
      hblComprador.Text = "";

    lblEstado.Text = "Subasta Activa.";


    // La subasta esta finalizada
    if (objSubasta.IDEstado == 3)
    {
      btnComprarAhora.Visible = false;
      btnPujar.Visible = false;
      txtPuja.Visible = false;
      lblPrecioSuperior.Visible = false;

      lblEstado.Text = "Subasta Finalizada.";

      if (usuario.IDUsuario == objSubasta.IDComprador)
      {
        hblVotarVendedor.Text = "Votar";
        hblVotarVendedor.NavigateUrl = "Votar.aspx";
      }
      else
      {
        hblVotarVendedor.Text = "";
        hblVotarVendedor.Visible = false;
      }

      if (usuario.IDUsuario == objSubasta.IDVendedor)
      {
        hblVotarComprador.Text = "Votar";
        hblVotarComprador.NavigateUrl = "Votar.aspx";
      }
      else
      {
        hblVotarComprador.Text = "";
        hblVotarComprador.Visible = false;
      }
    }


  }


    protected void Page_UnLoad(object sender, EventArgs e)
    {
      Session["objWCF"] = objWCF;
      Session["Usuario"] = usuario;
      Session["Subasta"] = objSubasta;
    }


    protected void btnComprarAhora_Click(object sender, EventArgs e)
    {
      if (usuario == null)
        Response.Redirect("ValidarUsuario.aspx");
      else
      {
        // Realizar el Comprar Ahora
        objSubasta.IDComprador = usuario.IDUsuario;
        int intResultado = objWCF.ComprarAhora(objSubasta);

        if (intResultado > 0)
        {
          Label1.Text = "Comprar Ahora ha sido realizado con xito.";
        }
        else
          Label1.Text = "Error al realizar el comprar ahora";
        
        objSubasta = objWCF.VerDetalleSubasta(objSubasta.IDSubasta);

        CargarDatos();
        txtPuja.Text = "";
      }
    }

    protected void btnPujar_Click(object sender, EventArgs e)
    {
      if (usuario == null)
        Response.Redirect("ValidarUsuario.aspx");
      else
      {
        double fltPrecioPuja;
        Double.TryParse(txtPuja.Text, out fltPrecioPuja);

        if (fltPrecioPuja<=0)
          Label1.Text = "El precio de la puja tiene que ser un nmero vlido.";

        if (fltPrecioPuja<objSubasta.PrecioActual)
          Label1.Text = "El precio de la puja tiene que ser superior al precio actual.";

        TPuja objPuja = new TPuja();
        objPuja.IDComprador = usuario.IDUsuario;
        objPuja.PrecioPuja = fltPrecioPuja;
        objPuja.IDSubasta = objSubasta.IDSubasta;


        int intResultado=objWCF.PujarSubasta(objPuja);

        if (intResultado > 0)
        {
          Label1.Text="La Puja ha sido realizada con xito.";
        }
        else
          Label1.Text = "Error al realizar la puja";

         
        objSubasta=objWCF.VerDetalleSubasta(objSubasta.IDSubasta);

        CargarDatos();
        txtPuja.Text = "";

      }
    }
}
