using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using System.IO;
using Service1;
using SubastasCli;

public partial class VerComentarios : System.Web.UI.Page
{
  Service1Client objWCF;
  TUsuario usuario;
  TTotalComentario objTTotalComentario;
  string strPaginaAnterior;

  private void ObtenerIDActual()
  {
    int intID;

    if (Request.QueryString["IDUsuario"] != null && Int32.TryParse((string)Request.QueryString["IDUsuario"], out intID))
    {
      if (intID > 0)
      {
        objTTotalComentario = objWCF.ConsultarComentarios(intID);
      }

    
    }
   
  }

  void Page_Load(object sender, EventArgs e)
  {

    if (!Page.IsPostBack)
    {

      usuario = (TUsuario)Session["Usuario"];
      objWCF = (Service1Client)Session["objWCF"];
      strPaginaAnterior = (string)Session["strPaginaAnterior"];

      if (objWCF == null)
        objWCF = new Service1Client();

      ObtenerIDActual();

      CargarDatos();


      strPaginaAnterior = Request.UrlReferrer.ToString();

    }
    else
    {
      objWCF = (Service1Client)Session["objWCF"];
      usuario = (TUsuario)Session["Usuario"];
      strPaginaAnterior = (string)Session["strPaginaAnterior"];
    }

 
    if (usuario != null)
    {
      lblUsuario.Text = "Usuario Validado : " + usuario.NickName;
      hblMisSubastas.NavigateUrl = "VerMisSubastas.aspx?IDUsuario=" + usuario.IDUsuario.ToString();

    }
    else
    {
      lblUsuario.Text = "";
      hblMisSubastas.Text = "Validar";
      hblMisSubastas.NavigateUrl = "ValidarUsuario.aspx";
    }


  }

    protected void Page_UnLoad(object sender, EventArgs e)
    {
      Session["objWCF"] = objWCF;
      Session["Usuario"] = usuario;
      Session["strPaginaAnterior"] = strPaginaAnterior;
    }

    protected void btnAtras_Click(object sender, EventArgs e)
    {
      Response.Redirect(strPaginaAnterior);
    }

    private void CargarDatos()
    {
      if (objTTotalComentario != null)
      {
        lblComentariosPositivos.Text = objTTotalComentario.TotalPositivo.ToString();
        lblComentariosNeutros.Text = objTTotalComentario.TotalNeutro.ToString();
        lblComentariosNegativos.Text = objTTotalComentario.TotalNegativo.ToString();
      }
      else
      {
        lblComentariosPositivos.Text = "---";
        lblComentariosNeutros.Text = "---";
        lblComentariosNegativos.Text = "---";
      }
    }

}
