using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using System.IO;
using Service1;
using SubastasCli;

public partial class Votar : System.Web.UI.Page
{
  Service1Client objWCF;
  TUsuario usuario;
  TTotalComentario objTTotalComentario;
  TSubasta objSubasta;
  string strPaginaAnterior;

  void Page_Load(object sender, EventArgs e)
  {

    if (!Page.IsPostBack)
    {

      usuario = (TUsuario)Session["Usuario"];
      objWCF = (Service1Client)Session["objWCF"];
      strPaginaAnterior = (string)Session["strPaginaAnterior"];
      objSubasta = (TSubasta)Session["Subasta"];

      if (objWCF == null)
        objWCF = new Service1Client();


      strPaginaAnterior = Request.UrlReferrer.ToString();

    }
    else
    {
      objWCF = (Service1Client)Session["objWCF"];
      usuario = (TUsuario)Session["Usuario"];
      objSubasta = (TSubasta)Session["Subasta"];
      strPaginaAnterior = (string)Session["strPaginaAnterior"];
    }


    if (usuario != null)
    {
      lblUsuario.Text = "Usuario Validado : " + usuario.NickName;
      hblMisSubastas.NavigateUrl = "VerMisSubastas.aspx?IDUsuario=" + usuario.IDUsuario.ToString();

    }
    else
    {
      lblUsuario.Text = "";
      hblMisSubastas.Text = "Validar";
      hblMisSubastas.NavigateUrl = "ValidarUsuario.aspx";
    }


  }

    protected void Page_UnLoad(object sender, EventArgs e)
    {
      Session["objWCF"] = objWCF;
      Session["Usuario"] = usuario;
      Session["strPaginaAnterior"] = strPaginaAnterior;
      Session["Subasta"] = objSubasta;
    }
  
    protected void btnCancelar_Click(object sender, EventArgs e)
    {
      Response.Redirect(strPaginaAnterior);
    }

    protected void btnVotar_Click(object sender, EventArgs e)
    {
      TComentario objComentario = new TComentario();
      //objSubasta, usuario.IDUsuario, 

      objComentario.IDSubasta = objSubasta.IDSubasta;
      int intVoto;
      Int32.TryParse(rbtnVotacion.SelectedValue.ToString(),out intVoto);
      if (objSubasta.IDComprador == usuario.IDUsuario)
        objComentario.IDComentarioVendedor = intVoto;
      if (objSubasta.IDVendedor == usuario.IDUsuario)
        objComentario.IDComentarioComprador = intVoto;
      
      if (objWCF.CrearComentario(objComentario)>0)
        Label1.Text="El comentario ha sido creado correctamente.";
      else
        Label1.Text="Error al crear el comentario.";
    }
}
