﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Runtime.Serialization;
using System.ServiceModel;
using System.Text;
using System.Data;
using SubastasWs.TClassBase;

namespace WcfServiceLibrary2
{
  
  // configuramos para instaciar por sessiones
  [ServiceBehavior(InstanceContextMode = InstanceContextMode.PerSession)]
  public class Service1 : IService1
  {
    public TUsuario objUsuario;
    public string hola;

    public TUsuario RegistrarUsuario(TUsuario _objUsuario)
    {
      if (_objUsuario.Insertar() > 0)
        return _objUsuario;
      else
        return null;
    }

    public TUsuario ValidarUsuario(string strUsuario,string strPassword)
    {

        // Validar usuario en sistema
      objUsuario = UsuarioValido(strUsuario, strPassword);
        if (objUsuario == null)
          return null;

       //string a = OperationContext.Current.SessionId;

      return objUsuario;

    }

    private TUsuario UsuarioValido(string strUsuario, string strPassword)
    {
      // validación en el sistema del usuario

      TUsuario objUsuario = new TUsuario();
      if (objUsuario.Validar(strUsuario, strPassword))
        return objUsuario;
      else
        return null;
    }

    public DataSet DimeArticulos()
    {
      TArticulo objArticulo = new TArticulo();

      return objArticulo.CargaDataSet();
    }

    public DataSet BuscarSubastasPorCategorias(int intIDCategoria)
    {
      TSubasta objSubasta = new TSubasta();

      return objSubasta.DimeSubastasActivas(intIDCategoria);
    }

    public DataSet BuscarMisSubastasPorCategorias(int intIDCategoria, int intIDUsuario)
    {

      string a = OperationContext.Current.SessionId;

      //if (objUsuario != null)
      //{

        TSubasta objSubasta = new TSubasta();

        return objSubasta.DimeMisSubastasFinalizadas(intIDCategoria, intIDUsuario);
      //}
      //else
      //  return null;
    }

    public DataSet BuscarSubastasPorNombre(string strNombre)
    {
      TSubasta objSubasta = new TSubasta();

      return objSubasta.DimeSubastasActivas(strNombre);
    }

    public DataSet BuscarCategorias()
    {



      TCategoria objCategoria = new TCategoria();

      return objCategoria.CargaDataSet();
    }

    public TSubasta VerDetalleSubasta(int intIDSubasta)
    {
      TSubasta objSubasta = new TSubasta();

      return objSubasta.DimeSubasta(intIDSubasta);
    }

    public int CrearSubasta(TSubasta objSubasta)
    {
      return objSubasta.Insertar();
    }

    public int PujarSubasta(TPuja objPuja)
    {
      return objPuja.Insertar();
    }

    public int ComprarAhora(TSubasta objSubasta)
    {
      return objSubasta.ComprarAhora();
    }

    public TTotalComentario ConsultarComentarios(int intID)
    {
      TTotalComentario objTotalComentario = new TTotalComentario();
      objTotalComentario.ConsultarComentarios(intID);

      return objTotalComentario;
    }

    public int CrearComentario(TComentario objComentario)
    {
      return objComentario.CrearComentario();
    }

    public DataSet VerPujas(int intSubasta)
    {
      TPuja objPuja = new TPuja();

      return objPuja.ConsultarPujas(intSubasta);
    }




  }
}
